unit TwitterAuthorizeUnit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.Memo.Types,
  FMX.StdCtrls, FMX.ScrollBox, FMX.Memo, FMX.Edit, FMX.Layouts, System.Rtti,
  FMX.Controls.Presentation, FMX.Objects, System.ImageList, FMX.ImgList,
  FMX.TabControl, System.JSON, System.IOUtils, System.DateUtils, FMX.Platform,
  FMX.Grid.Style, FMX.Grid, System.StrUtils, System.Threading, System.Generics.Collections,
  System.JSON.Serializers, System.JSON.Converters, FMX.ComboEdit,

  TTwitterBot2ClassUnit;

type
  TTwitterAuthorizeForm = class(TForm)
    TabControl1: TTabControl;
    TabItem1: TTabItem;
    TabItem2: TTabItem;
    TabItem3: TTabItem;
    Label1: TLabel;
    Layout3: TLayout;
    Label2: TLabel;
    Edit1: TEdit;
    Layout4: TLayout;
    Label3: TLabel;
    Edit2: TEdit;
    Layout5: TLayout;
    Label4: TLabel;
    Edit3: TEdit;
    Layout6: TLayout;
    Label5: TLabel;
    Edit4: TEdit;
    Label6: TLabel;
    Layout10: TLayout;
    Label10: TLabel;
    Edit8: TEdit;
    Layout9: TLayout;
    Label9: TLabel;
    Edit7: TEdit;
    Layout8: TLayout;
    Label8: TLabel;
    Edit6: TEdit;
    Layout7: TLayout;
    Label7: TLabel;
    Edit5: TEdit;
    Layout2: TLayout;
    Label13: TLabel;
    Edit11: TEdit;
    Layout12: TLayout;
    Label14: TLabel;
    Edit12: TEdit;
    Layout15: TLayout;
    Label15: TLabel;
    Edit13: TEdit;
    Layout16: TLayout;
    Layout17: TLayout;
    Circle1: TCircle;
    Button1: TButton;
    Label11: TLabel;
    Layout18: TLayout;
    Circle2: TCircle;
    Button2: TButton;
    Edit9: TEdit;
    Layout19: TLayout;
    Button7: TButton;
    Label16: TLabel;
    Rectangle2: TRectangle;
    Layout11: TLayout;
    Rectangle3: TRectangle;
    Layout14: TLayout;
    Circle3: TCircle;
    Button3: TButton;
    Label12: TLabel;
    Layout20: TLayout;
    Circle4: TCircle;
    Button4: TButton;
    Layout21: TLayout;
    Edit10: TEdit;
    Layout22: TLayout;
    Button5: TButton;
    Label17: TLabel;
    EllipsesEditButton1: TEllipsesEditButton;
    Layout13: TLayout;
    Label20: TLabel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Layout24: TLayout;
    Button6: TButton;
    Circle5: TCircle;
    Circle6: TCircle;
    Layout23: TLayout;
    Label18: TLabel;
    Edit15: TEdit;
    EditButton1: TEditButton;
    Memo1: TMemo;
    Layout26: TLayout;
    Button10: TButton;
    GridPanelLayout1: TGridPanelLayout;
    Memo2: TMemo;
    OpenDialog1: TOpenDialog;
    EditButton3: TEditButton;
    TabItem0: TTabItem;
    Layout27: TLayout;
    Layout28: TLayout;
    Label21: TLabel;
    Edit18: TEdit;
    Layout29: TLayout;
    Label22: TLabel;
    Edit19: TEdit;
    Layout30: TLayout;
    Label23: TLabel;
    Edit20: TEdit;
    Layout31: TLayout;
    Label24: TLabel;
    Edit21: TEdit;
    Layout32: TLayout;
    Label25: TLabel;
    Edit22: TEdit;
    Layout33: TLayout;
    Label26: TLabel;
    Edit23: TEdit;
    Layout34: TLayout;
    Label27: TLabel;
    Edit24: TEdit;
    Layout35: TLayout;
    Rectangle1: TRectangle;
    Button13: TButton;
    EditButton5: TEditButton;
    EditButton6: TEditButton;
    EditButton7: TEditButton;
    EditButton8: TEditButton;
    EditButton9: TEditButton;
    EditButton10: TEditButton;
    EditButton11: TEditButton;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Rectangle4: TRectangle;
    Rectangle5: TRectangle;
    Rectangle6: TRectangle;
    Rectangle7: TRectangle;
    Rectangle8: TRectangle;
    Rectangle9: TRectangle;
    Rectangle10: TRectangle;
    StyleBook1: TStyleBook;
    Edit17: TEdit;
    EditButton2: TEditButton;
    ClearEditButton1: TClearEditButton;
    Rectangle11: TRectangle;
    Label19: TLabel;
    Layout1: TLayout;
    Rectangle12: TRectangle;
    Rectangle13: TRectangle;
    StringGrid1: TStringGrid;
    GridPanelLayout2: TGridPanelLayout;
    Button9: TButton;
    Button11: TButton;
    CheckColumn1: TCheckColumn;
    StringColumn1: TStringColumn;
    StringColumn2: TStringColumn;
    ComboEdit1: TComboEdit;
    SpeedButton1: TSpeedButton;
    Image1: TImage;
    Layout25: TLayout;
    Button8: TButton;
    Edit14: TEdit;
    Button12: TButton;
    Timer1: TTimer;
    Layout36: TLayout;
    Label33: TLabel;
    Rectangle14: TRectangle;
    Label32: TLabel;
    CheckBox1: TCheckBox;
    Label34: TLabel;
    Label35: TLabel;
    procedure FormDestroy(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure EditButton1Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure EditButton2Click(Sender: TObject);
    procedure ClearEditButton1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure EditButton3Click(Sender: TObject);
    procedure PasteToken(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure EllipsesEditButton1Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure Button12Click(Sender: TObject);
  private
    FIsAnimatedGif: boolean;
    procedure SetGridString;
    procedure LoadJsonFromFile;
    procedure SaveJsonToFile;
    function v1_CtrlToJson: string;
    function v2_CtrlToJson: string;
    procedure v1_JsonToCtrl(Json: string);
    procedure v2_JsonToCtrl(Json: string);
    procedure v1_SetAuthState(State: TAuthState);
    procedure v2_SetAuthState(State: TAuthState);
    procedure RateLimitInfo;
  public
    procedure HttpResult(AResult: string);
    procedure AuthStateChanged(AuthState: TAuthState; APIVersion: TAPIVersion);
    procedure UrlChanged(NewUrl: string);
    procedure v1_SetJson(Json: string);
    procedure v2_SetJson(Json: string);
    procedure AddVideoMetaData(AText: string);
  end;

  procedure AddToLog(Text: string);

var
  TwitterAuthorizeForm: TTwitterAuthorizeForm;

  AppDir: string;
  LogQueue: TThreadList<string> = nil;

implementation

uses
  BrowserFormUnit, GifAnalyzeClassUnit;

{$R *.fmx}

const
  ScopeList: array[0..17] of string = (
    'tweet.read=All the Tweets you can view, including Tweets from protected accounts.',
    'tweet.write=Tweet and Retweet for you.',
    'tweet.moderate.write=Hide and unhide replies to your Tweets.',
    'users.read=Any account you can view, including protected accounts.',
    'follows.read=People who follow you and people who you follow.',
    'follows.write=Follow and unfollow people for you.',
    'offline.access=Stay connected to your account until you revoke access.',
    'space.read=All the Spaces you can view.',
    'mute.read=Accounts youfve muted.',
    'mute.write=Mute and unmute accounts for you.',
    'like.read=Tweets youfve liked and likes you can view.',
    'like.write=Like and un-like Tweets for you.',
    'list.read=Lists, list members, and list followers of lists youfve created or are a member of, including private lists.',
    'list.write=Create and manage Lists for you.',
    'block.read=Accounts youfve blocked.',
    'block.write=Block and unblock accounts for you.',
    'bookmark.read=Get Bookmarked Tweets from an authenticated user.',
    'bookmark.write=Bookmark and remove Bookmarks from Tweets');

  BooleanStr: array[boolean] of string = ('false', 'true');

procedure AddToLog(Text: string);
begin
  if Assigned(LogQueue) then
    LogQueue.Add(Text);
end;

function PasteText: string;
var
  Clipboard : IFMXClipboardService;
  Value: TValue;
begin
  result := '';
  if TPlatformServices.Current.SupportsPlatformService(IFMXClipboardService, Clipboard) then begin
    Value := Clipboard.GetClipboard;
    if (not Value.IsEmpty) and Value.IsType<string> then
      result := Value.ToString;
  end;
end;

procedure TTwitterAuthorizeForm.FormCreate(Sender: TObject);
begin
  AppDir :=  ExtractFileDir(ParamStr(0));
  LoadJsonFromFile;
  if not Edit1.Text.IsEmpty and not Edit8.text.IsEmpty then
    TabControl1.ActiveTab := TabItem1
  else
    TabControl1.ActiveTab := TabItem0;

  Rectangle12.Visible := false;
  SetGridString;

  LogQueue := TThreadList<string>.Create;
  Timer1.Enabled := true;

  FIsAnimatedGif := false;
end;

procedure TTwitterAuthorizeForm.FormDestroy(Sender: TObject);
begin
  TTwitterBot2ClassUnit.AppClosing := true;
  SaveJsonToFile;
  FreeAndNil(TwitterBot2);
  FreeAndNil(LogQueue);
end;

procedure TTwitterAuthorizeForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  TTwitterBot2ClassUnit.AppClosing := true;
end;

procedure TTwitterAuthorizeForm.FormResize(Sender: TObject);
begin
  SpeedButton1.Position.X := Self.ClientWidth - 26;
  SpeedButton1.Position.Y := 2;
end;

procedure TTwitterAuthorizeForm.FormShow(Sender: TObject);
begin
  TwitterBot2 := TTwitterBot2.Create;
  TwitterBot2.BrowserFormShow := BrowserForm.BrowserFormShow;
  TwitterBot2.AuthStateChanged := AuthStateChanged;

  TwitterBot2.SetJsonEvent_v1 := v1_SetJson;
  TwitterBot2.SetJsonEvent_v2 := v2_SetJson;

  TwitterBot2.v1_Tokens := v1_CtrlToJson;
  TwitterBot2.v2_Tokens := v2_CtrlToJson;

  TTwitterBot2ClassUnit.LogQueue := LogQueue;
  GifAnalyzeClassUnit.LogQueue := LogQueue;

  if not Button7.Enabled or not Button5.Enabled then
    TabControl1.ActiveTab := TabItem0
  else
    TabControl1.ActiveTab := TabItem3;

  Self.OnShow := nil;
end;

// Log
procedure TTwitterAuthorizeForm.Timer1Timer(Sender: TObject);
var
  List: TList<string>;
  S: string;
begin
  Timer1.Enabled := false;
  try
    if Assigned(LogQueue) then begin
      List := LogQueue.LockList;
      try
        while List.Count > 0 do begin
          s := List.Items[0];
          List.Delete(0);
          Memo1.Lines.Add(FormatDateTime('yyyy-mm-dd hh:nn:ss', now) + '-' + s);
          Memo1.GoToTextEnd;
        end;
      finally
        LogQueue.UnlockList;
      end;
    end;
  finally
    Timer1.Enabled := true;
  end;
end;

// paste tokens from Developer Portal
procedure TTwitterAuthorizeForm.Button13Click(Sender: TObject);
begin
  // v1
  Edit1.Text := Edit22.Text;
  Edit2.Text := Edit21.Text;

  Edit15.Text := '';
  Edit3.Text := '';
  Edit4.Text := '';

  v1_SetAuthState(TAuthState.osNoneAuthorized);

  // v2
  Edit8.Text := Edit24.Text;
  Edit7.Text := Edit23.Text;
  Edit13.Text := '';
  Edit12.Text := '';

  v2_SetAuthState(TAuthState.osNoneAuthorized);
end;

// start Authorize v1
procedure TTwitterAuthorizeForm.Button1Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) then begin
    Edit9.Text := '';
    TwitterBot2.v1_Tokens := v1_CtrlToJson;
    TwitterBot2.Authorize_v1;
  end;
end;

// Authorize v1 - step 2
procedure TTwitterAuthorizeForm.Button2Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) then
    TwitterBot2.GetAccessToken_v1(Edit9.Text); // PIN
end;

// start Authorize v2
procedure TTwitterAuthorizeForm.Button3Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) then begin
    Edit10.Text := '';
    TwitterBot2.v2_Tokens := v2_CtrlToJson;
    TwitterBot2.Authorize_v2;
  end;
end;

// Authorize v2 - step 2
procedure TTwitterAuthorizeForm.Button4Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) and Edit10.Text.Contains('code=') then begin
    TwitterBot2.GetAccessToken_v2(Edit10.Text);
    Button4.Enabled := false;
  end;
end;

procedure TTwitterAuthorizeForm.EditButton1Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) then
    TwitterBot2.BrowserNavigate(Edit5.Text);
end;

procedure TTwitterAuthorizeForm.PasteToken(Sender: TObject);
var
  AEdit: TEdit;
begin
  AEdit := nil;
  case (Sender as TEditButton).Tag of
    0: AEdit := Edit22;
    1: AEdit := Edit21;
    2: AEdit := Edit20;
    3: AEdit := Edit19;
    4: AEdit := Edit18;
    5: AEdit := Edit24;
    6: AEdit := Edit23;
  end;
  if Assigned(AEdit) then
    AEdit.Text := PasteText;

  if not Edit22.Text.IsEmpty and not Edit21.Text.IsEmpty and
     not Edit24.Text.IsEmpty and not Edit23.Text.IsEmpty then begin
    Button13.FontColor := TAlphaCOlorRec.Blue;
    Button13.TextSettings.Font.Style := [TFontStyle.fsBold];
  end;

end;

// browse
procedure TTwitterAuthorizeForm.Button6Click(Sender: TObject);
begin
  BrowserForm.BrowserFormShow(ComboEdit1.Text, '');
end;

function GetSizeM(v: Int64): string;
begin
  if v < 1048576 then
    result := (v / 1024).ToString(TFloatFormat.ffFixed, 7, 1) + 'KB'
  else
    result := (v / 1048576).ToString(TFloatFormat.ffFixed, 7, 1) + 'MB'

end;

function GifFrameCount(Filename: string): integer;
begin
  result := 0;

  var AniGif := TAnimatedGifClass.Create;
  try
    AniGif.LoadData(Filename);
    result := AniGif.ImageBlockCount;
  finally
    AniGif.Free;
  end;

end;

// open an image file
procedure TTwitterAuthorizeForm.EditButton2Click(Sender: TObject);
begin
  try
    FIsAnimatedGif := false;
    Image1.Bitmap := nil;
    Label34.Text := '';
    Label32.Text := '';

    OpenDialog1.Filter := 'image files|*.png;*.jpg;*.jpeg;*.gif' + '|video files|*.mp4';
    OpenDialog1.InitialDir := TPath.GetSharedPicturesPath;
    if OpenDialog1.Execute then begin
      Edit17.Text := OpenDialog1.FileName;
      var ExtStr := LowerCase(TPath.GetExtension(OpenDialog1.FileName));
      if ExtStr = '.gif' then begin
        var GifFrameCount := GifFrameCount(OpenDialog1.FileName);
        if GifFrameCount > 1 then begin
          FIsAnimatedGif := true;
          Memo1.Lines.Add('Gif frame count: ' + GifFrameCount.ToString);
          Memo1.GoToTextEnd;
        end;
        Image1.Bitmap.LoadFromFile(OpenDialog1.FileName);

      end else if ExtStr <> '.mp4' then begin
        Image1.Bitmap.LoadFromFile(OpenDialog1.FileName);

      end else begin
        Image1.Bitmap := nil;
        BrowserForm.ShowVideo(OpenDialog1.FileName);
      end;
      Label34.Text := GetMimeStr(OpenDialog1.FileName);
      Label32.Text := 'Size=' + GetSizeM(TFile.GetSize(OpenDialog1.FileName));
      if FIsAnimatedGif then
        Label32.Text := Label32.Text + ' Animated Gif';

    end;
  except
    on e: exception do
      if Assigned(LogQueue) then
        LogQueue.Add('TTwitterAuthorizeForm.EditButton2Click: ' + e.Message);
  end;
end;

procedure TTwitterAuthorizeForm.AddVideoMetaData(AText: string);
begin
  Label32.Text := 'Size=' + GetSizeM(TFile.GetSize(Edit17.Text)) +  ', ' + AText;
end;

procedure TTwitterAuthorizeForm.EditButton3Click(Sender: TObject);
begin
  Edit9.Text := PasteText;
end;

procedure TTwitterAuthorizeForm.ClearEditButton1Click(Sender: TObject);
begin
  Edit17.Text := '';
  Image1.Bitmap := nil;
end;

procedure TTwitterAuthorizeForm.EllipsesEditButton1Click(Sender: TObject);
var
  SArray: TStringDynArray;
begin
  SArray := SplitString(Edit6.Text, ' ');
  for var i := 0 to StringGrid1.RowCount - 1 do
    StringGrid1.Cells[0, i] := BooleanStr[IndexText(StringGrid1.Cells[1, i], SArray) >= 0];

  Rectangle12.Visible := true;
end;

// scopes - cancel
procedure TTwitterAuthorizeForm.Button11Click(Sender: TObject);
begin
  Rectangle12.Visible := false;
end;

procedure TTwitterAuthorizeForm.Button12Click(Sender: TObject);
begin
  RateLimitInfo;
end;

// scopes - apply
procedure TTwitterAuthorizeForm.Button9Click(Sender: TObject);
begin
  Rectangle12.Visible := false;

  Edit6.Text := '';
  for var i := 0 to StringGrid1.RowCount - 1 do
    if SameText(StringGrid1.Cells[0, i], 'true') then
      Edit6.Text := Edit6.Text + StringGrid1.Cells[1, i] + ' ';
  Edit6.Text := Trim(Edit6.Text);

end;

// post text with a image
procedure TTwitterAuthorizeForm.Button10Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) then begin
    if BrowserForm.Visible then
      BrowserForm.Hide;
    TwitterBot2.AsyncChunkedMediaUpload := CheckBox1.IsChecked;
    TwitterBot2.PostTweet(Memo2.Lines.Text + '-' + FormatDateTime('yyyy-mm-dd hh:nn:ss', now),
      Edit17.Text, FIsAnimatedGif,
      procedure (const AResult: string; const AuthStateChanged: boolean)
      begin
        AddToLog(AResult);
      end);
  end;
end;

// user info
procedure TTwitterAuthorizeForm.Button8Click(Sender: TObject);
begin
  if Assigned(TwitterBot2) then begin
      TwitterBot2.GetAboutMe(
        procedure (const AResult: string; const AuthStateChanged: boolean)
        begin
          Edit14.Text:= AResult;
        end);
  end;

end;

// show rate limit
procedure TTwitterAuthorizeForm.RateLimitInfo;
begin
  if not TwitterBot2.RateLimit.IsEmpty then
    Memo1.Lines.Add(TwitterBot2.RateLimit);
end;

procedure TTwitterAuthorizeForm.LoadJsonFromFile;
begin
  if TFile.exists('v1_Tokens.json') then
    v1_JsonToCtrl(TFile.ReadAllText('v1_Tokens.json', TEncoding.UTF8));
  if TFile.exists('v2_Tokens.json') then
    v2_JsonToCtrl(TFile.ReadAllText('v2_Tokens.json', TEncoding.UTF8));
end;

procedure TTwitterAuthorizeForm.SaveJsonToFile;
begin
  TFile.WriteAllText('v1_Tokens.json', v1_CtrlToJson, TEncoding.UTF8);
  TFile.WriteAllText('v2_Tokens.json', v2_CtrlToJson, TEncoding.UTF8);
end;

const
  CircleColor: array[boolean] of TAlphaColor = ($FFE0E0E0, $FF00FF00);

procedure TTwitterAuthorizeForm.v1_SetAuthState(State: TAuthState);
begin
  Circle1.Fill.Color := CircleColor[State = TAuthState.osNoneAuthorized];
  Circle2.Fill.Color := CircleColor[State = TAuthState.osInProcess];
  Circle6.Fill.Color := CircleColor[State = TAuthState.osAuthorized];

  Button1.Enabled := State = TAuthState.osNoneAuthorized;
  Button2.Enabled := State = TAuthState.osInProcess;
  Button7.Enabled := State = TAuthState.osAuthorized;
end;

procedure TTwitterAuthorizeForm.v2_SetAuthState(State: TAuthState);
begin
  Circle3.Fill.Color := CircleColor[State = TAuthState.osNoneAuthorized];
  Circle4.Fill.Color := CircleColor[State = TAuthState.osInProcess];
  Circle5.Fill.Color := CircleColor[State = TAuthState.osAuthorized];

  Button3.Enabled := State = TAuthState.osNoneAuthorized;
  Button4.Enabled := false;
  Button5.Enabled := State = TAuthState.osAuthorized;
end;

procedure TTwitterAuthorizeForm.v1_SetJson(Json: string);
begin
  v1_JsonToCtrl(Json);
end;

procedure TTwitterAuthorizeForm.v2_SetJson(Json: string);
begin
  v2_JsonToCtrl(Json);
end;

function TTwitterAuthorizeForm.v1_CtrlToJson: string;
var
  JSON: TJSONObject;
begin
  result := '';

  JSON := TJSONObject.Create;
  try
    JSON.AddPair('consumer_key', Edit1.Text);
    JSON.AddPair('consumer_key_secret', Edit2.Text);

    JSON.AddPair('bearer_token', Edit15.Text);

    JSON.AddPair('access_token', Edit3.Text);
    JSON.AddPair('access_token_secret', Edit4.Text);
    result := Json.ToString;
  finally
    JSON.Free;
  end;
end;

function TTwitterAuthorizeForm.v2_CtrlToJson: string;
var
  JSON: TJSONObject;
begin
  result := '';

  JSON := TJSONObject.Create;
  try
    JSON.AddPair('client_id', Edit8.Text);
    JSON.AddPair('client_id_secret', Edit7.Text);

    JSON.AddPair('scopes', Edit6.Text);
    JSON.AddPair('redirect_url', Edit5.Text);
    if RadioButton1.IsChecked then
      JSON.AddPair('challenge_method', 'plain')
    else
      JSON.AddPair('challenge_method', 'S256');

    JSON.AddPair('refresh_token', Edit13.Text);
    JSON.AddPair('bearer_token', Edit12.Text);
    JSON.AddPair('bearer_token_obtained_at', Edit11.Text);

    result := Json.ToString;
  finally
    JSON.Free;
  end;

end;

procedure TTwitterAuthorizeForm.v1_JsonToCtrl(Json:string);
var
  JSONObject: TJSONObject;
  JsonValue: TJsonValue;
begin
  JSONObject := nil;
  if not Json.IsEmpty then begin
    JSONObject := TJSONObject.ParseJSONValue(Json) as TJSONObject;
    if JSONObject <> nil then begin
      try
        if JSONObject.TryGetValue('consumer_key', JsonValue) then
          Edit1.Text := JsonValue.Value;
        if JSONObject.TryGetValue('consumer_key_secret', JsonValue) then
          Edit2.Text := JsonValue.Value;

        if JSONObject.TryGetValue('bearer_token', JsonValue) then
          Edit15.Text := JsonValue.Value;

        if JSONObject.TryGetValue('access_token', JsonValue) then
          Edit3.Text := JsonValue.Value;
        if JSONObject.TryGetValue('access_token_secret', JsonValue) then
          Edit4.Text := JsonValue.Value;

        if not Edit3.Text.IsEmpty and not Edit4.Text.IsEmpty then
          v1_SetAuthState(TAuthState.osAuthorized)
        else
          v1_SetAuthState(TAuthState.osNoneAuthorized);
      finally
        JSONObject.Free;
      end;
    end;
  end;

end;

procedure TTwitterAuthorizeForm.v2_JsonToCtrl(Json:string);
var
  JSONObject: TJSONObject;
  JsonValue: TJsonValue;
begin
  JSONObject := nil;
  if not Json.IsEmpty then begin
    JSONObject := TJSONObject.ParseJSONValue(Json) as TJSONObject;
    if JSONObject <> nil then begin
      try
        if JSONObject.TryGetValue('client_id', JsonValue) then
          Edit8.Text := JsonValue.Value;
        if JSONObject.TryGetValue('client_id_secret', JsonValue) then
          Edit7.Text := JsonValue.Value;

        if JSONObject.TryGetValue('scopes', JsonValue) then
          Edit6.Text := JsonValue.Value;
        if JSONObject.TryGetValue('redirect_url', JsonValue) then
          Edit5.Text := JsonValue.Value;
        if JSONObject.TryGetValue('challenge_method', JsonValue) then begin
          RadioButton1.IsChecked := JsonValue.Value = 'plain';
          //RadioButton2.IsChecked := JsonValue.Value <> 'plain';
        end;

        if JSONObject.TryGetValue('refresh_token', JsonValue) then
          Edit13.Text := JsonValue.Value;
        if JSONObject.TryGetValue('bearer_token', JsonValue) then
          Edit12.Text := JsonValue.Value;
        if JSONObject.TryGetValue('bearer_token_obtained_at', JsonValue) then
          Edit11.Text := JsonValue.Value;
        if Edit11.Text.IsEmpty then
          Edit11.Text := DateToISO8601(0, false);

        if not Edit13.Text.IsEmpty and not Edit12.Text.IsEmpty then
          v2_SetAuthState(TAuthState.osAuthorized)
        else
          v2_SetAuthState(TAuthState.osNoneAuthorized);

      finally
        JSONObject.Free;
      end;
    end;
  end;
end;

procedure TTwitterAuthorizeForm.SetGridString;
var
  Text: string;
  SArray: TStringDynArray;
begin
  StringGrid1.RowCount := High(ScopeList) + 1;
  for var i := 0 to High(ScopeList) do begin
    Text := ScopeList[i];
    SArray := SplitString(Text, '=');
    if Length(SArray) = 2 then begin
      StringGrid1.Cells[0, i] := 'false';
      StringGrid1.Cells[1, i] := SArray[0];
      StringGrid1.Cells[2, i] := SArray[1];
    end;
  end;
end;

procedure TTwitterAuthorizeForm.SpeedButton1Click(Sender: TObject);
begin
  {$IFDEF MSWINDOWS}
  var Bitmap := TabControl1.MakeScreenshot;
  if Assigned(Bitmap) then begin
    try
      var Folder := ExtractFileDir(ParamStr(0)) + PathDelim + 'ScreenShot';
      if not TDirectory.Exists(Folder) then
        TDirectory.CreateDirectory(Folder);

      Bitmap.SaveToFile(Folder + PathDelim + FormatDateTime('yyyymmdd-hhnnss', Now) + '.png');
    finally
      Bitmap.Free;
    end;
  end;
  {$ENDIF}
end;

procedure TTwitterAuthorizeForm.HttpResult(AResult: string);
begin
  TFile.WriteAllText('TwitterHome.html', AResult);
end;

procedure TTwitterAuthorizeForm.AuthStateChanged(AuthState: TAuthState; APIVersion: TAPIVersion);
begin
  if APIVersion = TAPIVersion.av11 then
    v1_SetAuthState(AuthState)
  else
    v2_SetAuthState(AuthState);
end;

procedure TTwitterAuthorizeForm.UrlChanged(NewUrl: string);
begin
  if (TabControl1.ActiveTab = TabItem2) and not Button3.Enabled and not Button5.Enabled then begin
    Edit10.Text := NewUrl;
    Button4.Enabled := NewUrl.Contains('code=');
  end;
end;

end.
